<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1, shrink-to-fit=no"
    />
    <meta name="description" content="" />
    <meta name="author" content="" />

    <title></title>

    <!-- Custom fonts for this template-->

    <link
      href="https://fonts.googleapis.com/css?family=Nunito:200,200i,300,300i,400,400i,600,600i,700,700i,800,800i,900,900i"
      rel="stylesheet"
    />

    <!-- Custom styles for this template-->
    <link href="css/sb-admin-2.min.css" rel="stylesheet" />
    <link
      href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.13.0/css/all.min.css"
      rel="stylesheet"
      type="text/css"
    />
    <link
      href="https://fonts.googleapis.com/css?family=Nunito:200,200i,300,300i,400,400i,600,600i,700,700i,800,800i,900,900i"
      rel="stylesheet"
    />

    <link
      href="https://cdn.jsdelivr.net/npm/startbootstrap-sb-admin-2@4.0.7/css/sb-admin-2.min.css"
      rel="stylesheet"
    />
    <link
      rel="stylesheet"
      type="text/css"
      href="https://cdn.datatables.net/v/dt/jszip-2.5.0/dt-1.12.1/b-2.2.3/b-colvis-2.2.3/b-html5-2.2.3/b-print-2.2.3/cr-1.5.6/fh-3.2.4/kt-2.7.0/r-2.3.0/rg-1.2.0/rr-1.2.8/sc-2.0.7/sb-1.3.4/sp-2.0.2/sl-1.4.0/datatables.min.css"
    />
  </head>

  <body id="page-top">
    <!-- Page Wrapper -->
    <div id="wrapper">
      <!-- Sidebar -->
      <ul
        class="navbar-nav bg-gradient-primary sidebar sidebar-dark accordion"
        id="accordionSidebar"
      >
        <!-- Sidebar - Brand -->
        <a
          class="sidebar-brand d-flex align-items-center justify-content-center"
          href="index.html"
        >
          <div class="sidebar-brand-icon rotate-n-15">
            <img src="img/logo.png" width="20" />
          </div>
          <div class="sidebar-brand-text mx-3">dsplus<sup></sup></div>
        </a>

        <!-- Divider -->
        <hr class="sidebar-divider my-0" />

        <!-- Nav Item - Dashboard -->
        <li class="nav-item">
          <a class="nav-link" href="index.html">
            <i class="fas fa-fw fa-tachometer-alt"></i>
            <span>Dashboard</span></a
          >
        </li>

        <!-- Divider -->
        <hr class="sidebar-divider" />

        <!-- Heading -->

        <!-- Heading -->

        <!-- Nav Item - Projects Collapse Menu -->
        <li class="nav-item active">
          <a
            class="nav-link"
            href="#"
            data-toggle="collapse"
            data-target="#collapseProjects"
            aria-expanded="true"
            aria-controls="collapseProjects"
          >
            <i class="fas fa-fw fa-folder"></i>
            <span>Projects</span>
          </a>
          <div
            id="collapseProjects"
            class="collapse show"
            aria-labelledby="headingProjects"
            data-parent="#accordionSidebar"
          >
            <div
              class="bg-white py-2 collapse-inner rounded"
              id="projects"
            ></div>
          </div>
        </li>

        <!-- Divider -->
        <hr class="sidebar-divider d-none d-md-block" />

        <!-- Sidebar Toggler (Sidebar) -->
        <div class="text-center d-none d-md-inline">
          <button class="rounded-circle border-0" id="sidebarToggle"></button>
        </div>
      </ul>
      <!-- End of Sidebar -->

      <!-- Content Wrapper -->
      <div id="content-wrapper" class="d-flex flex-column">
        <!-- Main Content -->
        <div id="content">
          <!-- Topbar -->
          <nav
            class="navbar navbar-expand navbar-light bg-white topbar mb-4 static-top shadow"
          >
            <!-- Sidebar Toggle (Topbar) -->
            <button
              id="sidebarToggleTop"
              class="btn btn-link d-md-none rounded-circle mr-3"
            >
              <i class="fa fa-bars"></i>
            </button>

            <!-- Topbar Navbar -->
            <ul class="navbar-nav ml-auto">
              <!-- Nav Item - Search Dropdown (Visible Only XS) -->
              <li class="nav-item dropdown no-arrow d-sm-none">
                <a
                  class="nav-link dropdown-toggle"
                  href="#"
                  id="searchDropdown"
                  role="button"
                  data-toggle="dropdown"
                  aria-haspopup="true"
                  aria-expanded="false"
                >
                  <i class="fas fa-search fa-fw"></i>
                </a>
                <!-- Dropdown - Messages -->
                <div
                  class="dropdown-menu dropdown-menu-right p-3 shadow animated--grow-in"
                  aria-labelledby="searchDropdown"
                >
                  <form class="form-inline mr-auto w-100 navbar-search">
                    <div class="input-group">
                      <input
                        type="text"
                        class="form-control bg-light border-0 small"
                        placeholder="Search for..."
                        aria-label="Search"
                        aria-describedby="basic-addon2"
                      />
                      <div class="input-group-append">
                        <button class="btn btn-primary" type="button">
                          <i class="fas fa-search fa-sm"></i>
                        </button>
                      </div>
                    </div>
                  </form>
                </div>
              </li>
            </ul>
          </nav>
          <!-- End of Topbar -->

          <!-- Begin Page Content -->
          <div class="container-fluid">
            <!-- Page Heading -->
            <h1 class="h3 mb-4 text-gray-800" id="project"></h1>

            <div class="row">
              <div class="col-xl-3 col-md-6 mb-4">
                <div class="card border-left-info shadow h-100 py-2">
                  <div class="card-body">
                    <div class="row no-gutters align-items-center">
                      <div class="col mr-2">
                        <div
                          class="text-xs font-weight-bold text-info text-uppercase mb-1"
                        >
                          Projects
                        </div>
                        <div
                          class="h5 mb-0 font-weight-bold text-gray-800"
                          id="assets"
                        ></div>
                      </div>
                      <div class="col-auto">
                        <i class="fas fa-cubes fa-2x text-gray-300"></i>
                      </div>
                    </div>
                  </div>
                </div>
              </div>

              <div class="col-xl-3 col-md-6 mb-4">
                <div class="card border-left-warning shadow h-100 py-2">
                  <div class="card-body">
                    <div class="row no-gutters align-items-center">
                      <div class="col mr-2">
                        <div
                          class="text-xs font-weight-bold text-warning text-uppercase mb-1"
                        >
                          Issues
                        </div>
                        <div
                          class="h5 mb-0 font-weight-bold text-gray-800"
                          id="issues"
                        ></div>
                      </div>
                      <div class="col-auto">
                        <i
                          class="fas fa-exclamation-circle fa-2x text-gray-300"
                        ></i>
                      </div>
                    </div>
                  </div>
                </div>
              </div>
            </div>
            <div class="row">
              <div class="col-sm-2 mb-4 d-none" id="blocker">
                <div class="card border-left-dark shadow h-100 py-2">
                  <div class="card-body">
                    <div class="row no-gutters align-items-center">
                      <div class="col mr-2">
                        <div
                          class="text-xs font-weight-bold text-success text-uppercase mb-1"
                        >
                          Blocker
                        </div>
                        <div
                          class="h5 mb-0 font-weight-bold text-gray-800"
                          id="cblocker"
                        ></div>
                      </div>
                      <div class="col-auto">
                        <i class="fas fa-radiation fa-2x text-gray-300"></i>
                      </div>
                    </div>
                  </div>
                </div>
              </div>

              <div class="col-sm-2 mb-4 d-none" id="critical">
                <div class="card border-left-danger shadow h-100 py-2">
                  <div class="card-body">
                    <div class="row no-gutters align-items-center">
                      <div class="col mr-2">
                        <div
                          class="text-xs font-weight-bold text-success text-uppercase mb-1"
                        >
                          Critical
                        </div>
                        <div
                          class="h5 mb-0 font-weight-bold text-gray-800"
                          id="ccritical"
                        ></div>
                      </div>
                      <div class="col-auto">
                        <i class="fas fa-bomb fa-2x text-gray-300"></i>
                      </div>
                    </div>
                  </div>
                </div>
              </div>
              <div class="col-sm-2 mb-4 d-none" id="major">
                <div class="card border-left-warning shadow h-100 py-2">
                  <div class="card-body">
                    <div class="row no-gutters align-items-center">
                      <div class="col mr-2">
                        <div
                          class="text-xs font-weight-bold text-success text-uppercase mb-1"
                        >
                          Major
                        </div>
                        <div
                          class="h5 mb-0 font-weight-bold text-gray-800"
                          id="cmajor"
                        ></div>
                      </div>
                      <div class="col-auto">
                        <i class="fas fa-times fa-2x text-gray-300"></i>
                      </div>
                    </div>
                  </div>
                </div>
              </div>

              <div class="col-sm-2 mb-4 d-none" id="minor">
                <div class="card border-left-primary shadow h-100 py-2">
                  <div class="card-body">
                    <div class="row no-gutters align-items-center">
                      <div class="col mr-2">
                        <div
                          class="text-xs font-weight-bold text-success text-uppercase mb-1"
                        >
                          Minor
                        </div>
                        <div
                          class="h5 mb-0 font-weight-bold text-gray-800"
                          id="cminor"
                        ></div>
                      </div>
                      <div class="col-auto">
                        <i
                          class="fas fa-exclamation-circle fa-2x text-gray-300"
                        ></i>
                      </div>
                    </div>
                  </div>
                </div>
              </div>

              <div class="col-sm-2 mb-4 d-none" id="info">
                <div class="card border-left-info shadow h-100 py-2">
                  <div class="card-body">
                    <div class="row no-gutters align-items-center">
                      <div class="col mr-2">
                        <div
                          class="text-xs font-weight-bold text-success text-uppercase mb-1"
                        >
                          Information
                        </div>
                        <div
                          class="h5 mb-0 font-weight-bold text-gray-800"
                          id="cinfo"
                        ></div>
                      </div>
                      <div class="col-auto">
                        <i class="fas fa-info fa-2x text-gray-300"></i>
                      </div>
                    </div>
                  </div>
                </div>
              </div>
            </div>
            <div class="row">
              <div class="col-6">
                <!-- Area Chart -->

                <div class="card shadow mb-4">
                  <!-- Card Header - Dropdown -->
                  <div
                    class="card-header py-3 d-flex flex-row align-items-center justify-content-between"
                  >
                    <h6 class="m-0 font-weight-bold text-primary">Overview</h6>
                  </div>
                  <!-- Card Body -->
                  <div class="card-body">
                    <div style="height: 40vh">
                      <canvas class="chartjs" id="metricsChart"></canvas>
                    </div>
                  </div>
                </div>
              </div>
              <div class="col-6">
                <!-- Area Chart -->

                <div class="card shadow mb-4">
                  <!-- Card Header - Dropdown -->
                  <div
                    class="card-header py-3 d-flex flex-row align-items-center justify-content-between"
                  >
                    <h6 class="m-0 font-weight-bold text-primary">Projects</h6>
                  </div>
                  <!-- Card Body -->
                  <div class="card-body">
                    <div style="height: 40vh">
                      <canvas class="chartjs" id="projectsChart"></canvas>
                    </div>
                  </div>
                </div>
              </div>
              <div class="col-6">
                <!-- Area Chart -->

                <div class="card shadow mb-4">
                  <!-- Card Header - Dropdown -->
                  <div
                    class="card-header py-3 d-flex flex-row align-items-center justify-content-between"
                  >
                    <h6 class="m-0 font-weight-bold text-primary">Issues</h6>
                  </div>
                  <!-- Card Body -->
                  <div class="card-body">
                    <div id="issues2">
      
                    </div>
                  </div>
                </div>
              </div>
            </div>

       
            <!-- /.container-fluid -->
          </div>
          <!-- End of Main Content -->

          <!-- Footer -->

          <!-- End of Footer -->
        </div>
        <!-- End of Content Wrapper -->
      </div>
    </div>
    <!-- End of Page Wrapper -->

    <!-- Scroll to Top Button-->
    <a class="scroll-to-top rounded" href="#page-top">
      <i class="fas fa-angle-up"></i>
    </a>

    <!-- Logout Modal-->
    <div
      class="modal fade"
      id="logoutModal"
      tabindex="-1"
      role="dialog"
      aria-labelledby="exampleModalLabel"
      aria-hidden="true"
    >
      <div class="modal-dialog" role="document">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="exampleModalLabel">Ready to Leave?</h5>
            <button
              class="close"
              type="button"
              data-dismiss="modal"
              aria-label="Close"
            >
              <span aria-hidden="true">×</span>
            </button>
          </div>
          <div class="modal-body">
            Select "Logout" below if you are ready to end your current session.
          </div>
          <div class="modal-footer">
            <button
              class="btn btn-secondary"
              type="button"
              data-dismiss="modal"
            >
              Cancel
            </button>
            <a class="btn btn-primary" href="login.html">Logout</a>
          </div>
        </div>
      </div>
    </div>

    <!-- Bootstrap core JavaScript-->

    <!-- Custom scripts for all Projects-->
  </body>
</html>

<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.1.1/jquery.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.4.1/js/bootstrap.bundle.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery-easing/1.4.1/jquery.easing.min.js"></script>

<script
  type="text/javascript"
  src="https://cdnjs.cloudflare.com/ajax/libs/pdfmake/0.1.36/pdfmake.min.js"
></script>
<script
  type="text/javascript"
  src="https://cdnjs.cloudflare.com/ajax/libs/pdfmake/0.1.36/vfs_fonts.js"
></script>
<script
  type="text/javascript"
  src="https://cdn.datatables.net/v/dt/jszip-2.5.0/dt-1.12.1/b-2.2.3/b-colvis-2.2.3/b-html5-2.2.3/b-print-2.2.3/cr-1.5.6/fh-3.2.4/kt-2.7.0/r-2.3.0/rg-1.2.0/rr-1.2.8/sc-2.0.7/sb-1.3.4/sp-2.0.2/sl-1.4.0/datatables.min.js"
></script>

<script src="https://cdnjs.cloudflare.com/ajax/libs/Chart.js/3.8.0/chart.min.js"></script>
<script src="js/sb-admin-2.min.js"></script>

<script type="text/javascript">
  const sevMap = {
    info: 'info',
    minor: 'primary',
    major: 'warning',
    critical: 'danger',
    blocker : 'dark'
  }
  var metricsChart = {
    type: "radar",
    data: {
      datasets: [],
      labels: [
        "proportion",
        "complexity",
        "cost",
        "documentation",
        "atomicity",
        "granularity",
      ],
    },
    options: {
      responsive: true,

      maintainAspectRatio: false,
      scale: { ticks: { beginAtZero: true } },
    },
  };
  var projectsChart = {
    type: "doughnut",
    data: {
      labels: [],
      datasets: [
        {
          label: "Size",
          data: [],
          backgroundColor: [],
        },
      ],
    },
    options: {
      responsive: true,

      maintainAspectRatio: false,
      plugins: {
        legend: {
          position: "top",
        },
        title: {
          display: true,
          text: "Projects Size",
        },
      },
    },
  };
  $(document).ready(function (e) {
    var palette = [
      "rgba(251, 248, 204,0.5",
      "rgba(185, 251, 192,0.5",
      "rgba(253, 228, 207,0.5",
      "rgba(255, 207, 210,0.5",
      "rgba(241, 192, 232,0.5",
      "rgba(152, 245, 225,0.5",
      "rgba(207, 186, 240,0.5",
      "rgba(163, 196, 243,0.5",
      "rgba(142, 236, 245,0.5",
      "rgba(144, 219, 244,0.5",
    ];
    document.title = "dashboard";
    const mctx = document.getElementById("metricsChart").getContext("2d");
    const mChart = new Chart(mctx, metricsChart);
    const pctx = document.getElementById("projectsChart").getContext("2d");
    const pChart = new Chart(pctx, projectsChart);
    $.getJSON("data/projects.json", function (data) {
      $("#assets").text(data.length);
      data.map((p) => {
        $("#projects").append(
          `<a class="collapse-item" href="issues.html?project=${p.name}">${p.name}</a>`
        );
        $("#issues2").append(
          `<a href="issues.html?project=${p.name}">${p.name}</a><div class="progress" id="issues_${p.name}"></div>`
        );
        var project = p.name;

        $.getJSON("data/" + project + ".overview.json", function (data) {
          const overview = data[0];

          var color = palette.shift();
          //delete palette[_rand]
          projectsChart.data.labels.push(project);
          projectsChart.data.datasets[0].data.push(overview.metrics.size);
          projectsChart.data.datasets[0].backgroundColor.push(color);

          //console.log(projectsChart);
          pChart.update();
          mChart.data.datasets.push({
            backgroundColor: color,
            borderColor: color,
            pointBorderColor: "#fff",
            pointHoverBackgroundColor: "#fff",
            data: [
              overview.metrics["proportion"],
              overview.metrics["complexity"],
              overview.metrics["cost"],
              overview.metrics["documentation"],
              overview.metrics["atomicity"],
              overview.metrics["granularity"],
            ],
            label: project,
          });

          // metricsChart.data.labels = Object.keys(overview.metrics);

          mChart.update();
        }).fail(function () {
          console.log(project, "error");
        });

        var counters = {};
      });
    });
    $.getJSON("data/issues.history.json", function (data) {
      var issues = {};
      var allissues = 0
      data.map((d) => {
        if (!issues[d.project] || issues[d.project].date < d.date) {
          issues[d.project] = d;
          allissues=allissues+(Object.values(issues[d.project].issues).reduce((a,b) => (a+b),0))
          $("#issues").textallissues
        }
      });
      //console.log(issues);
      var counters = {};
      
      Object.keys(issues).map((p) => {
   
        var _issues = Object.keys(issues[p].issues).map((key) => [
          key,
          issues[p].issues[key],
        ]);
        var total = _issues.reduce((p, v) => p + v[1], 0);
        
        _issues.map((i) => {
          var percent = (i[1] * 100) / total;
          //console.log(p, i, percent, total);
          counters[i[0]] = (counters[i[0]] || 0) + i[1];
          $("#issues").text(parseInt($("#issues").html() || 0) + i[1]);
          //ar allissues=parseInt($("#issues").html() || 0)
         console.log(p,allissues,total)
          $("#issues_" + p).attr('style','width:'+(100*total/allissues)+'%;')
          $("#issues_" + p).append(
            '<div class="progress-bar bg-' +
              sevMap[i[0]]+
              '" role="progressbar" style="width: ' +
              percent +
              '%" aria-valuenow="' +
              percent +
              '" aria-valuemin="0" aria-valuemax="100">' +
              i[1] +
              "</div>"
          );
        });
        Object.keys(counters).map((c) => {
          $("#c" + c).text(counters[c]);
          $("#" + c).removeClass("d-none");
        });
      });
    });
  });
</script>
